/*
 * 消息盒子(底部弹出)
 */

vPortalMainFrameElements.messageBottom = {
		messageCategoryCount:{},//消息按内容分类count(@我的,我跟踪的,领导的等等等)
		messageCategoryArray:{},//消息按内容分类存储消息对象
		allMessages:{},//所有消息 无序
		allMessageIds : new Array(),//全部盒子内消息有序
		messageAppCategoryArray:{},//按应用分类存储消息
		appMap : {},//appId:appName
		appList : [],//有消息的应用,按消息来的先后顺序存起来,展示分类的时候使用
		selectCategory : "",
        //获取消息盒子的数据
        getData: function() {
            return vPortal.messageOperationTypes;
        },
        beforeInit : function(){
        	if("operation"==vPortal.messageShowType){
            	var data=callBackendMethod("portalManager", "getMessageCustomConfig", "pc");
            	if(data){
            		vPortal.messageOperationTypes=data;
            	}
            	vPortalMainFrameElements.messageBottom.initMessageCategory();
            }
        	vPortalMainFrameElements.messageBottom.selectCategory = vPortal.messageShowType+"_all";
        },
        //初始化，元素如果有初始化的事件请写在这里面
        init: function() {
            //初始化消息
            if( vPortal.offline && vPortal.offline==true  || vPortal.subPortal == "true"){
                document.getElementById("messageBlock").style.display = 'none';
            	return;
            }else{
            	//在线人数和人员在线状态轮询
                initMessage(vPortal.messageIntervalSecond);
            }
            //临时动作，默认展开消息盒子
            // vPortalMainFrameElements.messageBottom.toggleMsgbox();

            vPortalMainFrameElements.messageBottom.isDrag = false;
            //消息框 - 小 （拖拽） noneDiv：在iframe添加的透明层方便拖拽
            $("#messageBlock").draggable({
                revert: false,
                containment: "html",
                scroll: false,
                iframeFix: true,
                start:function(event, ui) {
                    $(".noneDiv").show();
                    vPortalMainFrameElements.messageBottom.isDrag = true;
                },
                stop:function(event, ui) {
                    if(ui.position.top < 0 ){
                        $("#messageBlock").css({
                            "top":"",
                            "left":""
                        });
                    }
                }
            });

        },
        //打开消息设置弹出框
        showMessageSet :function(url){
              var dialog = $.dialog({
                id: 'showMessageSet',
                url: url,
                width: $(getCtpTop()).width() - 100,
                height: 600,
                title: $.i18n("message.setting.title"),
                targetWindow: getCtpTop()
              });
        },
        //更多消息、未读消息
        showMoreMessage : function(src) {
          try{
            layer.closeAll()
          }catch(error){
            throw "关闭dialog失败"+error;
          }
          //缩小的消息盒子是否显示小圆点
          vPortalMainFrameElements.messageBottom.showOrHideSysMsgRemind();
          //最小化消息盒子
          vPortalMainFrameElements.messageBottom.toggleMsgbox();
          if(src){
        	  showMenu(src);
          }else{
        	  var url='/seeyon/message.do?method=messageCenter&from=box';
        	  if("operation"==vPortal.messageShowType){
        		  var selected = vPortalMainFrameElements.messageBottom.selectCategory.split("_")[1];
        		  url = url + "&selectedCategory="+ selected;
        	  }
        	  url = url + "&uu=";
        	  showMenu(url);
          }
        },
        //隐藏OR显示消息盒子  from参数传入 showMsgbox的时候，无论之前什么状态都显示消息盒子
        toggleMsgbox: function(from){
            if(vPortalMainFrameElements.messageBottom.isDrag){
                vPortalMainFrameElements.messageBottom.isDrag = false;
                return;
            }
            var _Msgbox = document.getElementById("messageBottom");
            var _Msgblock = document.getElementById("messageBlock");
            var _MsgboxState = _Msgbox.getAttribute("class");
            if(_MsgboxState.indexOf("display_none")>-1){
                _Msgbox.setAttribute("class", "messageBottom");
                _Msgblock.setAttribute("class", "messageBlock display_none ui-draggable ui-draggable-handle");
            }else if(from != "showMsgbox"){//来消息的时候不隐藏，其他情况才隐藏
                _Msgbox.setAttribute("class", "messageBottom display_none");
                _Msgblock.setAttribute("class", "messageBlock ui-draggable ui-draggable-handle");
            }
        },
        //隐藏OR显示消息盒子里面的分类   已废弃
        toggleMsgExpansionBox:function(){
            var _MsgExpansionBox = document.getElementById("msgExpansionBox");
            var _MsgExpansionToggleIcon = document.getElementById("msgExpansionToggleIcon");
            var _MsgExpansionBoxState = _MsgExpansionBox.getAttribute("class");
            if(_MsgExpansionBoxState.indexOf("display_none")>-1){
                _MsgExpansionBox.setAttribute("class", "msgExpansionBox");
                _MsgExpansionToggleIcon.setAttribute("class", "vportal vp-arrow-down-serif");
            }else{
                _MsgExpansionBox.setAttribute("class", "msgExpansionBox display_none");
                _MsgExpansionToggleIcon.setAttribute("class", "vportal vp-arrow-up-serif");
                
            }  
        },
        //追加新到来的消息？？？好像没用到了
        prependNewSysMsg: function(content) {
            $("#messageUl").prepend(content);
        },
        //把消息标记为已读
        markSysMsgReaded: function(userHistoryMessageId) {
            var msgCategoryValue = $("#sysMsgDiv" + userHistoryMessageId).attr("msgCategory");
            var readed = $("#sysMsgDiv" + userHistoryMessageId).attr("readed");
            if (!readed) {
                $("#sysMsgDiv" + userHistoryMessageId).attr("readed", "true");
                var curCount = $("#msgCategory" + msgCategoryValue + "Count").html();
                curCount = parseInt(curCount);
                var resultCount = curCount - 1;
                if (resultCount <= 0) {
                    $("#msgCategory" + msgCategoryValue + "Count").parent().remove();
                } else {
                    $("#msgCategory" + msgCategoryValue + "Count").html(resultCount);
                }
                vPortalMainFrameElements.messageBottom.updateSysMessageNum(0, -1);
                vPortal.sectionHandler.messageTemplete.updateAllMessageSection(userHistoryMessageId);
            }
            $("#sysMsgDiv" + userHistoryMessageId).find(".messageLiRight").css("color", "#999999");
        },
        //分类显示消息条数,msgCategory:消息应用分类,num:增加或减少的数量          废弃后面可删除
        /*showMsgByUnreadCategory: function(msgCategory, num) {
            if (msgCategory && msgCategory != "") {
                var splitedArray = msgCategory.split("|");
                var msgCategoryValue = splitedArray[0];
                var msgCategoryName = splitedArray[1];
                var len = $("#msgCategory" + msgCategoryValue + "Count").length;
                if (len == 0) {
                    if (msgCategoryName.length > 4) {
                        msgCategoryName = msgCategoryName.substring(0, 4) + "...";
                    }
                    var html = "<div onclick='javascript:vPortalMainFrameElements.messageBottom.msgCategoryClick(this);' class='msgExpansionBoxMain' msgCategory='" + msgCategoryValue + "'>" + msgCategoryName + "<span id='msgCategory" + msgCategoryValue + "Count'>" + num + "</span>条<i onclick='javascript:vPortalMainFrameElements.messageBottom.sysMessageIgnore(this);' title='" + $.i18n("portal.message.ignore") + "' class='msgIgnore msgIgnoreCategory vportal vp-ignore'></i></div>";
                    $("#msgExpansionBox").append(html);
                } else {
                    var curCount = $("#msgCategory" + msgCategoryValue + "Count").html();
                    curCount = parseInt(curCount);
                    var resultCount = curCount + num;
                    if (resultCount <= 0) {
                        $("#msgCategory" + msgCategoryValue + "Count").parent().remove();
                    } else {
                        $("#msgCategory" + msgCategoryValue + "Count").html(resultCount);
                    }
                }
            }
        },*/
        //点击管理员切换皮肤风格的消息，自动切换单位及皮肤风格
        switchAccount: function(portalTemplateId) {
            //alert("待开发，，，点击换肤功能");

            /*$("#skin_set_close").click();
            var allowTemplateChooseSetting = getCtpTop().$.getSwitchPortalTemplate("false", "false");
            if(allowTemplateChooseSetting == null){
              return;
            }
            portalTemplateManagerObject.getCurrentPortalTemplateAndHotSpots({
              success : function(data){
                  getCtpTop().$.ctx.template = $.parseJSON(data);
                  getCtpTop().refreshCtxHotSpotsData();
                  getCtpTop().$.initHotspots();
              }
            });*/
            
        },
        //忽略消息事件绑定入口
        sysMessageIgnore:function(obj,event){
            if(obj.getAttribute("class").indexOf("msgIgnoreCategory") != -1){
                //忽略某类型消息
                var msgCategoryValue = $(obj).parent().attr("msgCategory");
                var msgs = $(".msg_remove[msgCategory='" + msgCategoryValue + "']");
                var len = msgs.length;
                if (len && len > 0) {
                    getCtpTop().updateSystemMessageStateByCategory(msgCategoryValue);
                }
                msgs.remove();
                vPortalMainFrameElements.messageBottom.updateSysMessageNum(-len, -len);
                $(obj).parent().remove();
            }else{
                //忽略单条消息
                var msg_remove = $(obj).parent().parent().parent().parent();
                var userHistoryMessageId = $(msg_remove).attr("userHistoryMessageId");
                vPortalMainFrameElements.messageBottom.ignoreSysMsg(userHistoryMessageId);
                stopProp(event);
            }

        },
        //忽略单条消息
        ignoreSysMsg:function(userHistoryMessageId){
            var msg_remove = $("#sysMsgDiv" + userHistoryMessageId);
            var msgCategory = $(msg_remove).attr("msgCategory");
            var userHistoryMessageId = $(msg_remove).attr("userHistoryMessageId");
            updateMessageState(userHistoryMessageId, this, "a8");
            var readed = $(msg_remove).attr("readed");
            if(!readed){
              //不要了,用messageAppCategoryArray[appId].length;//vPortalMainFrameElements.messageBottom.showMsgByUnreadCategory(msgCategory, -1);
              vPortalMainFrameElements.messageBottom.updateSysMessageNum(-1, -1);
            } else {
              vPortalMainFrameElements.messageBottom.updateSysMessageNum(-1, 0);
            }
            vPortalMainFrameElements.messageBottom.deleteMessageCache(userHistoryMessageId);
            vPortal.sectionHandler.messageTemplete.updateAllMessageSection(userHistoryMessageId);
            $("#"+userHistoryMessageId).each(function(){
            	$(this).addClass("read");
            });
            $(msg_remove).remove();
        },
        //更新系统消息条数
        updateSysMessageNum: function(msgTotalCount, unreadMsgCount) {
            //得到当前条数
            vPortal.sysMsgTotalCount1 = vPortal.sysMsgTotalCount1 + parseInt(msgTotalCount);
            vPortal.sysMsgTotalCount2 = vPortal.sysMsgTotalCount2 + parseInt(unreadMsgCount);
            if (vPortal.sysMsgTotalCount1 <= 0) {
                vPortal.sysMsgTotalCount1 = 0;
            }
            if (vPortal.sysMsgTotalCount2 <= 0) {
                vPortal.sysMsgTotalCount2 = 0;
                getCtpTop().standardTitleFun();
            }
            //更新条数
            $("#sysMsgTotalCount1").html(vPortal.sysMsgTotalCount1 + "");
            $("#sysMsgTotalCount2").html(vPortal.sysMsgTotalCount2 + "");
            vPortalMainFrameElements.messageBottom.showOrHideSysMsgRemind();

        },
        //更新一下#messageUl高度  needCalculation为是否显示分类的标识
        updateUlHeight : function (needCalculation) { 
            if(!needCalculation){
                this.fixTab("messageBottomTab");
                //有分类的时候计算
                $("#messageUl").height("auto");
                $("#messageUl").height($("#messageUl").height());
            }else{
                //没有分类的时候不计算
                $("#messageUl").height("auto");    
            }
        },
        //忽略全部
        ignoreAllSysMsg:function(){
            var msgs = $(".msg_remove");
            var msglen = msgs.length;
            if (msglen && msglen > 0) {
                getCtpTop().updateSystemMessageStateByUser();
            }
            

            //数量清零
            vPortal.sysMsgTotalCount1 = 0;
            vPortal.sysMsgTotalCount2 = 0;
            $("#sysMsgTotalCount1").html(vPortal.sysMsgTotalCount1 + "");
            $("#sysMsgTotalCount2").html(vPortal.sysMsgTotalCount2 + "");
            

            //缩小的消息盒子是否显示小圆点
            vPortalMainFrameElements.messageBottom.showOrHideSysMsgRemind();
            //最小化消息盒子
            vPortalMainFrameElements.messageBottom.toggleMsgbox();
            
            //删除消息、消息分类、
            $(".msg_remove").remove();
            $(".msgExpansionBoxMain").remove();
            $(".msgExpansionBox").attr("class","msgExpansionBox display_none")
            //忽略全部的时候清除缓存
            vPortalMainFrameElements.messageBottom.initMessageCategory();
            //刷新分类显示
            vPortalMainFrameElements.messageBottom.showMessagesTabs();
            vPortal.sectionHandler.messageTemplete.updateAllMessageSection();
            getCtpTop().standardTitleFun();
        },
        //缩小的消息盒子是否显示小圆点
        showOrHideSysMsgRemind: function() {
            if (vPortal.sysMsgTotalCount2 > 0) {
                $(".msg_remind").show();
            }else{
                $(".msg_remind").hide();
            }
        },
        //消息盒子 分类点击
        msgCategoryClick :function(obj){
            var msgCategory = $(obj).attr("msgCategory");
            if (msgCategory && msgCategory != "") {
                vPortalMainFrameElements.messageBottom.showMoreMessage(_ctxPath + "/message.do?method=showMessages&showType=0&readType=notRead&condition=messageCategory&textfield1=" + msgCategory.split("|")[0]+"&uu="+new Date().getTime());
            }
        },
        //分类页签点击的动作
        findMessages:function(id,type){
        	var selected=document.getElementById(vPortalMainFrameElements.messageBottom.selectCategory);
        	if(!type){
        		type=vPortal.messageShowType;
        	}
        	if(!id){
        		if(selected){//如果选中的分类还存在就展示该分类内容
        			id=vPortalMainFrameElements.messageBottom.selectCategory.split("_")[1];
        		}else{
        			id="all";
        		}
        	}
            $("#tab_messageBottomTab span").removeClass('thisSelected');
            //type有时候带逗号把逗号replace掉,否则取dom对象为空
            var t=vPortalMainFrameElements.messageBottom.replaceComma(type);
        	$("#"+t+"_"+id).addClass("thisSelected");
        	vPortalMainFrameElements.messageBottom.selectCategory = type+"_"+id;
        	if(id=="all"){
        		var messages=vPortalMainFrameElements.messageBottom.allMessageIds;
        		$("#messageUl").empty();
        		vPortal.sysMsgTotalCount1 = 0;
                vPortal.sysMsgTotalCount2 = 0;
                vPortalMainFrameElements.messageBottom.reLoadMessages(messages);
        	}else{
        		var messages;
        		if(type=="app"){
        			messages=vPortalMainFrameElements.messageBottom.messageAppCategoryArray[id];
        		}else{
        			messages=vPortalMainFrameElements.messageBottom.messageCategoryArray[id];
        		}
        		$("#messageUl").empty();
        		vPortal.sysMsgTotalCount1 = 0;
                vPortal.sysMsgTotalCount2 = 0;
                vPortalMainFrameElements.messageBottom.reLoadMessages(messages);
        	}
        	
        },replaceComma : function (v){
        	return v.replace(/,/g,"_");
        },
        //动态生成页签分类......
        showMessagesTabs:function(){
        	var _parameter=new Array();
        	if("operation"==vPortal.messageShowType){
        		var opTypes=vPortal.messageOperationTypes;
        		//组织要展示的分类
        		_parameter.push({id:"all",name:$.i18n("section.panel.all.label"),type:"operation",num:vPortalMainFrameElements.messageBottom.allMessageIds.length});
        		for(var i=0;i<opTypes.length;i++){
        			var opTypeId=opTypes[i].id;
        			opTypeId=vPortalMainFrameElements.messageBottom.replaceComma(opTypeId);
        			var displayName=opTypes[i].displayName;
        			if(vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]>0){
        				_parameter.push({id:opTypeId,name:displayName,type:"operation",num:vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]});
        			}
        		}
        	}else{
        		//组织要展示的分类
        		_parameter.push({id:"all",name:$.i18n("section.panel.all.label"),type:"app",num:vPortalMainFrameElements.messageBottom.allMessageIds.length});
        		for(var i=0;i<vPortalMainFrameElements.messageBottom.appList.length;i++){
        			var app=vPortalMainFrameElements.messageBottom.appList[i];
        			var appId=app.id;
        			var appName=app.name;
        			var count=0;
        			if(vPortalMainFrameElements.messageBottom.messageAppCategoryArray[appId]){
        				count=vPortalMainFrameElements.messageBottom.messageAppCategoryArray[appId].length;
        			}
        			if(count>0){
        				_parameter.push({id:appId,name:appName,type:"app",num:count});
        			}
        		}
        	}
            //消息条数小于等于4条时，默认不显示分类
            if(vPortalMainFrameElements.messageBottom.allMessageIds.length>4){
                $("#tab_messageBottomTab span").remove();
                var msgCategoryHtml = new StringBuffer();
                for(var i=0; i<_parameter.length; i++){
                    msgCategoryHtml.append('<span class="tabSpan '+(i==0?" thisSelected":"")+'" id="'+_parameter[i].type+"_"+_parameter[i].id+'" displayName="'+_parameter[i].name+'" onclick="javascript:vPortalMainFrameElements.messageBottom.findMessages(\''+_parameter[i].id+'\',\''+_parameter[i].type+'\')">'+_parameter[i].name+'('+_parameter[i].num+')</span>');
                }
                msgCategoryHtml = msgCategoryHtml.toString();
                $("#tab_messageBottomTab").prepend(msgCategoryHtml);
                $("#tab_messageBottomTab").show();
                this.fixTab("messageBottomTab");
            }else{
                $("#tab_messageBottomTab").hide();
                this.updateUlHeight("false");

            }
        },
        //是否显示下拉的算法。。。。。。。。。。
        fixTab:function(objId){
            //消息盒子栏目有页签....
            /********下拉箭头相关代码开始*********/
            var tabObj = document.getElementById("tab_"+objId);
            if(tabObj == null) return;
            
            var tabObjMore = document.getElementById("tabMore_messageBottomTab");
            var boxWidth = tabObj.offsetWidth;
            var spanArr = tabObj.querySelectorAll("span");
            var tabObjLength = tabObj.querySelectorAll("span").length;
            var spanMargin = 12;//页签的右间距
            var spanHeight = 26;//pop里面的行高
            var borderWidth = 2;//每个span的border宽度
            var objPadding = 15;//tab页签的左右padding和


            tabObj.style.overflow = 'hidden';
            if(tabObj.className.indexOf("hasArrow") > -1){
                tabObj.className = "msgTab ";
                tabObj.style.overflow = 'auto';
            }

            //判断是否内容是否溢出...   点击页签下拉里面的时候，需要结合&&后面的条件来判断
             if(tabObj.scrollHeight > tabObj.clientHeight &&   tabObjMore.querySelectorAll("span").length == 0) {

                if(tabObj.className.indexOf("hasArrow") == -1){
                    tabObj.className = tabObj.className + " hasArrow";
                }


                var moreIconWidth = 30 + borderWidth;//下拉箭头的宽度
                var increaseWidth = moreIconWidth;
                var spanIndex = 0;
                var spanPadding = 40;//span页签的左右padding和
                

                for(var i =0 ; i< tabObjLength; i++ ){
                    var thisWidth = spanArr[i].offsetWidth + spanMargin;
                    increaseWidth = increaseWidth + thisWidth;
                    if(increaseWidth - spanMargin > boxWidth - objPadding){

                        for(var d = 0 ; d< i; d++ ){
                            //最后一个margin-right为0
                            if(d == i-1){
                                tabObj.querySelectorAll("span")[d].style.marginRight = '0px';
                            }
                        }


                        //把显示不下的页签克隆到tabMore  DIV,标记被挪走的页签，方便后续删除
                        spanIndex = i;
                        var moreStr = "";
                        for(var k = i ; k< tabObjLength; k++ ){
                            var _node = tabObj.querySelectorAll("span")[k].cloneNode(true);
                            tabObjMore.appendChild(_node);
                            tabObj.querySelectorAll("span")[k].className = 'diaplay_none';
                        }

                        //菜单是否显示在上面
                        if(tabObj.className.indexOf("hasArrow") == -1){
                            tabObj.className = tabObj.className + " hasArrow";
                        }

                        break;
                    }
                }


                //删除已经挪动到tabMore  DIV里面的页签
                var tabHiddenObj = tabObj.querySelectorAll(".diaplay_none");
                var tabHiddenObjLength = tabObj.querySelectorAll(".diaplay_none").length;
                for(var i =0 ; i< tabHiddenObjLength; i++ ){
                    tabObj.removeChild(tabHiddenObj[i]);
                }
            }

            //下拉框max-height更新，点击页签的时候也需要更新  
            var popHeight = tabObjMore.querySelectorAll("span").length * 26;
            var messageUlHeight = document.getElementById("messageUl").offsetHeight;

            tabObjMore.style.maxHeight = messageUlHeight+'px';

            if(tabObjMore.querySelectorAll("span").length > 0){
                tabObj.className = "msgTab hasArrow";
            }
            tabObj.style.overflow = 'visible';
            /********下拉箭头相关代码结束*********/
        },
        reLoadMessages:function(messages){
            try {
                if (messages && messages.length > 0) {
                    var messagePerList = new Array();
                    var messageSysList = new Array();
                    if (!isA8geniusMsg) {
                        var linkTypes = new Set();
                    }
                    var m = 0;
                    for (var i = 0; i < messages.length; i++) {
                        var message = vPortalMainFrameElements.messageBottom.allMessages[messages[i]];
                        if(!message){
                        	continue;
                        }
                        var referenceId = message["R"];
                        var userHistoryMessageId = message["H"];
                        var messageCategory = message["MC"];
                        var content = message["C"] || "";
                        var messageType = message["T"];
                        var senderId = message["S"];
                        var senderName = message["N"];
                        var accountShortName = message["SN"];
                        var receiverId = "";
                        var receiverName = "";
                        var creationDateTime = message["D"];
                        var verifyCode = message["VC"];
                        var linkType = message["L"];
                        var isAtMe = message["IA"];
                        var isReply = message["IR"];
                        var isTrack = message["ITR"];
                        var isTemplate = message["ITM"];
                        var templateId = message["TMI"];

                        //精灵NC消息过滤链接（无法打开）
                        if (isA8geniusMsg && linkType == "message.link.NC.message") {
                            linkType = null;
                        }

                        var link = linkType;
                        if (messageType == 0 && linkType) { //有链接
                            if (!isA8geniusMsg) {
                                linkTypes.add(linkType);
                            }
                            var l = 0;
                            while (true) {
                                var param = message['P' + l];

                                if (!param) {
                                    break;
                                }

                                link += "|" + param;

                                l++;
                            }
                        }

                        var openType = parseInt(message["O"], 10);
                        var atts = message["A"];
                        var importantLevel = message["I"];

                        if (!(link && link.indexOf("leaveWord") != -1)) {
                            content = content.escapeHTML();
                        }
                        if (verifyCode != null && verifyCode != "") {
                            link = link + "|vc:" + verifyCode;
                        }
                        var  isFromAI = message["AI"];
                        var msg = new CLASS_MESSAGE("", "", referenceId, userHistoryMessageId, content, messageType, senderId, senderName, receiverId, receiverName, creationDateTime, link, openType, atts, importantLevel, messageCategory,isAtMe,isReply,isTrack,isTemplate,templateId,isFromAI);
                        msg.accountShortName = accountShortName;
                        messageSysList[m++] = msg;
                    }
                    showMessage(null, messageSysList, 0, "a8","reLoadMessages");
                }
            } catch (e) {
                
            }

        },
        //从缓存中删除一条消息
        deleteMessageCache:function(msgId){
        	if("operation"==vPortal.messageShowType){
        		for(var category in vPortalMainFrameElements.messageBottom.messageCategoryArray){
        			for(var i=0;i<vPortalMainFrameElements.messageBottom.messageCategoryArray[category].length;i++){
        				if(vPortalMainFrameElements.messageBottom.messageCategoryArray[category][i]==msgId){
        					var msgs=vPortalMainFrameElements.messageBottom.messageCategoryArray[category];
        					vPortalMainFrameElements.messageBottom.messageCategoryArray[category]=msgs.slice(0,i).concat(msgs.slice(i+1,msgs.length));
        					vPortalMainFrameElements.messageBottom.messageCategoryCount[category]--;
        					break;
        				}
        			}
        		}
        	}else{
        		for(var category in vPortalMainFrameElements.messageBottom.messageAppCategoryArray){
        			for(var i=0;i<vPortalMainFrameElements.messageBottom.messageAppCategoryArray[category].length;i++){
        				if(vPortalMainFrameElements.messageBottom.messageAppCategoryArray[category][i]==msgId){
        					var msgs=vPortalMainFrameElements.messageBottom.messageAppCategoryArray[category];
        					vPortalMainFrameElements.messageBottom.messageAppCategoryArray[category]=msgs.slice(0,i).concat(msgs.slice(i+1,msgs.length));
        					break;
        				}
        			}
        		}
        	}
        	for(var i=0;i<vPortalMainFrameElements.messageBottom.allMessageIds.length;i++){
        		var id=vPortalMainFrameElements.messageBottom.allMessageIds[i];
        		if(id==msgId){
        			var msgs=vPortalMainFrameElements.messageBottom.allMessageIds;
        			vPortalMainFrameElements.messageBottom.allMessageIds = msgs.slice(0,i).concat(msgs.slice(i+1,msgs.length));
        			break;
        		}
        	}
        	delete vPortalMainFrameElements.messageBottom.allMessages[msgId];
        	vPortalMainFrameElements.messageBottom.showMessagesTabs();
        	vPortalMainFrameElements.messageBottom.findMessages();
        },
        //初始化消息缓存
        initMessageCategory:function(){
        	if("operation"==vPortal.messageShowType && vPortal.messageOperationTypes && vPortal.messageOperationTypes.length>0){
        		var opTypes=vPortal.messageOperationTypes;
        		for(var i=0;i<opTypes.length;i++){
        			vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypes[i].id]=0;
        			vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypes[i].id]=new Array();
        		}
        	}else{
        		vPortalMainFrameElements.messageBottom.messageAppCategoryArray={};
        	}
        	vPortalMainFrameElements.messageBottom.allMessages = {};
        	vPortalMainFrameElements.messageBottom.allMessageIds = new Array();
        },
        //push消息到消息缓存
        pushMessage:function(msg){
        	vPortalMainFrameElements.messageBottom.allMessages[msg.H]=msg;
        	vPortalMainFrameElements.messageBottom.allMessageIds.unshift(msg.H);
        	//如果配置了消息内容分类
        	if("operation"==vPortal.messageShowType && vPortal.messageOperationTypes && vPortal.messageOperationTypes.length>0){
        		var opTypes=vPortal.messageOperationTypes;
        		for(var i=0;i<opTypes.length;i++){
        			var opTypeId=opTypes[i].id;
        			var dataType=opTypes[i].c;
        			if((opTypeId=='atMe' && msg.IA=='1')){
        				vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]++;
        				vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypeId].unshift(msg.H);
        			}
        			if(opTypeId=='replyMe' && msg.IR=='1'){
        				vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]++;
        				vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypeId].unshift(msg.H);
        			}
        			if(opTypeId=='myTrack' && msg.ITR=='1'){
        				vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]++;
        				vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypeId].unshift(msg.H);
        			}
        			if(opTypeId=='important' && msg.I > 1){
        				vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]++;
        				vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypeId].unshift(msg.H);
        			}
        			if(dataType=="p"){
        				if(opTypes[i].values && (msg.S+"").length>4 && opTypes[i].values.indexOf(msg.S)>-1){
        					vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]++;
        					vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypeId].unshift(msg.H);
        				}
        			}
        			if(dataType=="t"){
        				if(opTypes[i].values && opTypes[i].values.indexOf(msg.TMI)>-1){
        					vPortalMainFrameElements.messageBottom.messageCategoryCount[opTypeId]++;
        					vPortalMainFrameElements.messageBottom.messageCategoryArray[opTypeId].unshift(msg.H);
        				}
        			}
        		}
        	}else{
        		if(msg["MC"]){
            		//按应用分类
        			var app=msg["MC"].split("|");
            		var appId=app[0];
            		var appName=app[1];
            		if(!vPortalMainFrameElements.messageBottom.messageAppCategoryArray[appId]){
            			vPortalMainFrameElements.messageBottom.messageAppCategoryArray[appId]=new Array();
            		}
                	vPortalMainFrameElements.messageBottom.messageAppCategoryArray[appId].unshift(msg.H);
                	if(!vPortalMainFrameElements.messageBottom.appMap[appId]){
                		vPortalMainFrameElements.messageBottom.appList.push({id:appId,name:appName});
                	}
                	vPortalMainFrameElements.messageBottom.appMap[appId]=appName;
            	}
        	}
        	vPortalMainFrameElements.messageBottom.showMessagesTabs();
        	vPortal.sectionHandler.refreshMessageSection(msg);
        }
        
}