/*
 * 顶部右侧操作区
 */
vPortalMainFrameElements.skinSet = {
    config: false,
    getData: function() {
    	if(!vPortal.themeCategorys){
    		vPortal.themeCategorys = callBackendMethod("portalThemeManager", "getThemeCategorys");
    	}
        return vPortal.themeCategorys;
    },
    hideSkinPanle: function() {
        var panleObj = document.getElementById("skin_set");
        var skin_content = document.getElementById("skin_content");
        panleObj.className = "skin_set_contaner display_none";
        panleObj.style.height = "0";
        panleObj.style.display = "none";
        skin_content.innerHTML = '';
        if(getCtpTop() && getCtpTop().openSkinPanle != "1"){
            if(getCtpTop()["removeOnbeforeunload"]!=null){
                getCtpTop()["removeOnbeforeunload"]();
            }
        	getCtpTop().location.href="/seeyon/main.do?method=changeLoginAccount&isPortalTemplateSwitching=true&login.accountId="+vPortal.CurrentUser.loginAccount;
        }
    },
    // 布局设置和皮肤设置切换
    chooseOperate: function(_num) {
        var _contentWindow = document.getElementById("skin_content")
            .querySelector("iframe").contentWindow;
       if(_contentWindow){
    	   _contentWindow.loadLayout(_num);
       }
       if(vPortal.themeCategorys){
    	   for(var i=0;i<vPortal.themeCategorys.length;i++){
    		   var temp = document.getElementById("theme_category_"+vPortal.themeCategorys[i].code);
    		   temp.setAttribute("class", "padding_l_5 hand padding_r_5")
    	   }
       }
       var span = document.getElementById("theme_category_"+_num);
       span.setAttribute("class", "padding_l_5 hand padding_r_5 choosed")
    },
    spaceSet: function() {
        var dwidth = $(top).width();
        var dheight = $(top).height();
        var vPortalWindowDialog = $.dialog({
            targetWindow: top,
            id: 'spaceSetDialog',
            url: "/seeyon/portal/portalDesigner.do?method=vPortalEngineIndex&securityType=0&selected=space&from=dialog",
            width: dwidth,
            height: dheight,
            title: "空间设置",
            overflow: 'hidden',
            transParams: {
                vPortalWindowDialogObj: window
            },
            closeParam: {
                'show': true,
                handler: function() {
                    if(getCtpTop()["removeOnbeforeunload"]!=null){
                        getCtpTop()["removeOnbeforeunload"]();
                    }
                    var currentPortalUrl = _ctxPath + "/main.do?method=changeLoginAccount";
        	    	getCtpTop().location.href = currentPortalUrl;
                }
            }
        });
    },
    // 空间导航设置
    configSpaceNav: function() {
        var navDialog = $
            .dialog({
                targetWindow: top,
                id: 'navDialog',
                url: '/seeyon/portal/portalDesigner.do?method=navigationSelect&portalId=' +
                    vPortal.portalId,
                width: 820,
                height: 495,
                title: '请选择导航',
                overflow: 'hidden',
                buttons: [{
                    id: 'ok',
                    isEmphasize: true,
                    text: "确定",
                    handler: function() {
                        var nav = navDialog.getReturnValue();
                        callBackendMethod(
                            "portalNavManager",
                            "savePortalNav",
                            nav,
                            vPortal.portalId, {
                                success: function(data) {
                                	$.infor("保存成功!");
                                    navDialog.close();
                                    if(parent.getCtpTop()["removeOnbeforeunload"]!=null){
                                        parent.getCtpTop()["removeOnbeforeunload"]();
                                    }
                                    parent.getCtpTop().location.href = "/seeyon/main.do?method=changeLoginAccount&isPortalTemplateSwitching=true&login.accountId=" +
                                        vPortal.CurrentUser.loginAccount;
                                },
                                error: function(msg) {}
                            });
                    }
                }, {
                    id: 'cancel',
                    text: "取消",
                    handler: function() {
                        navDialog.close();
                    }
                }]
            });
    },
    // 菜单设置
    menusSet: function() {
        var menuDialog = $
            .dialog({
                targetWindow: top,
                id: 'menuDialog',
                url: '/seeyon/portal/portalDesigner.do?method=menuSelect&portalId=' +
                    vPortal.portalId,
                width: 355,
                height: 355,
                title: '请选择菜单 (通过拖动同级菜单进行排序)',
                overflow: 'hidden',
                buttons: [{
                    id: 'ok',
                    isEmphasize: true,
                    text: "确定",
                    handler: function() {
                        var menus = menuDialog.getReturnValue();
                        if (menus == false) {
                            return;
                        }
                        callBackendMethod(
                            "portalNavManager",
                            "savePortalMenus",
                            menus,
                            vPortal.portalId,
                            "0", {
                                success: function(data) {
                                    menuDialog.close();
                                    if(parent.getCtpTop()["removeOnbeforeunload"]!=null){
                                        parent.getCtpTop()["removeOnbeforeunload"]();
                                    }
                                    parent.getCtpTop().location.href = "/seeyon/main.do?method=changeLoginAccount&isPortalTemplateSwitching=true&login.accountId=" +
                                        vPortal.CurrentUser.loginAccount;
                                },
                                error: function(msg) {
                                    $.alert("菜单保存失败!");
                                }
                            });
                    }
                }, {
                    id: 'cancel',
                    text: "取消",
                    handler: function() {
                        menuDialog.close();
                    }
                }]
            });
    },
    // 快捷设置
    quickMenu: function() {
        var quickMenuDialog = $
            .dialog({
                id: 'quickMenuSetDialog_Id',
                width: 520,
                height: 400,
                title: $.i18n("personalSetting.shortcut.label"),
                targetWindow: top,
                url: '/seeyon/portal/portalController.do?method=showShortcutSet',
                closeParam: {
                    'show': true,
                    handler: function() {
                        quickMenuDialog.close();
                    }
                },
                minParam: {
                    show: false
                },
                maxParam: {
                    show: false
                },
                buttons: [{
                    text: $.i18n('common.button.ok.label'),
                    isEmphasize: true,
                    handler: function() {
                        var returnValue = quickMenuDialog
                            .getReturnValue({
                                "innerButtonId": "saveNew"
                            });
                        if (returnValue && returnValue == 0) {

                        } else if (returnValue && returnValue == 1) {
                            $
                                .messageBox({
                                    'title': "提示",
                                    'type': 0,
                                    'msg': "<span class='msgbox_img_0 left'></span><span class='margin_l_5 padding_5'>保存成功</span>",
                                    ok_fn: function() {
                                        if(getCtpTop()["removeOnbeforeunload"]!=null){
                                            getCtpTop()["removeOnbeforeunload"]();
                                        }
                                        //refreshShortCutMenu();
                                        getCtpTop().location.href="/seeyon/main.do?method=changeLoginAccount&isPortalTemplateSwitching=true&showSkinchoose=1&login.accountId="+vPortal.CurrentUser.loginAccount;
                                    },
                                    close_fn: function() {
                                        if(getCtpTop()["removeOnbeforeunload"]!=null){
                                            getCtpTop()["removeOnbeforeunload"]();
                                        }
                                        //refreshShortCutMenu();
                                    	getCtpTop().location.href="/seeyon/main.do?method=changeLoginAccount&isPortalTemplateSwitching=true&showSkinchoose=1&login.accountId="+vPortal.CurrentUser.loginAccount;
                                    }
                                });
                        }
                        quickMenuDialog.close();
                    }
                }, {
                    text: $.i18n('common.button.cancel.label'),
                    handler: function() {
                        quickMenuDialog.close();
                    }
                }]
            });
    }
}