/*
 * logo
 */

vPortalMainFrameElements.slideVPortalNew = {
    slideVPortalDataJson : new Object(),
    slideVPortalPropJson : new Object(),
	config: false,
    //ajax 获取幻灯片数据
    getData: function() {
        // 取数据
    	var themeId = vPortal.themeId;
    	var portalId = vPortal.portalId;
        var result = callBackendMethod("slideVPortalManager","getSlideByPortalId",themeId,portalId);
        if(result == null ) return "";
        result._w = document.getElementById("wrapper").offsetWidth;
        this.slideVPortalDataJson = result;
        if(vPortal.offline && window.parent.dataJson && window.parent.dataJson.slide){//设置是否显示幻灯片
        	result.showSlide = window.parent.dataJson.slide.showSlide;
        }else{
        	if(vPortal.themeHotspots && vPortal.themeHotspots.slide){
        		result.showSlide = vPortal.themeHotspots.slide.showSlide;
        	}else{
        		result.showSlide = "1";
        	}
        }
        return result;
    },
    //初始化幻灯片
    afterInit: function(_elementId) {
        var _slideVPortalDom = document.getElementById(_elementId);
        if ($('.slideVPortalDetail').find("li").length != 0) {
            $.ajax({
                url: "/seeyon/decorations/js/jquery.slide.js",
                type: 'get',
                dataType: 'script',
                success: function(data) {
                    $(_slideVPortalDom.children[0]).slide({
                        width: "100%",
                        height: 300,
                        delayTime: parseInt(_slideVPortalDom.children[0].getAttribute("speed")),
                        startingSlide: 0,
                        effect: 'horizental',
                        slidePage: true,
                        slideTitle: true,
                        slideRemove: true,
                        autoAdapt:true
                    });
                },
                error: function() {
                    console.error("no tpl js：" + _result.Data.resolveFunction);
                }
            });
        }
    },
    //设计器中获取可设置属性
    getProp : function(_dataJson){
        window.parent.changeRightTitle('幻灯片设置');
        var dataJson = this.slideVPortalDataJson;
        var arrayValue = new Array();
        var value = "";
        if (dataJson.value != null && dataJson.value != "") {
            arrayValue = JSON.parse(dataJson.value);
            value = "已选择";
        }
		var json = [ {
			"groupName" : "",
			"groupValue" : [ {
				"id" : "",
				"name" : "",
				"type" : "checkbox",
				"label" : "",
				"typeChoose" : "default",
				"value" : [ {
					"label" : "显示幻灯片",
					"id" : "showSlide",
					"name" : "showSlide",
					"checked" : (!window.parent.dataJson.slide
							|| (!window.parent.dataJson.slide.showSlide && window.parent.dataJson.slide.showSlide != '0') || window.parent.dataJson.slide.showSlide == '1') ? "on"
							: "off"
				} ],
				"click" : "clickFun"
			} ]
		} ];
		if(vPortal.admin == 'true'){//非管理员不允许设置热点(是否显示除外)
			json[0].groupValue.push({
                "id" : "backgroundPicture",
                "name" : "backgroundPicture",
                "type" : "text",
                "label" : "背景图片",
                "typeChoose" : "uploadImg",
                "sliderChoose" : true,
                "hiddenField" : arrayValue,
                "typeShow" : "default",
                "value" : value
            });
			json[0].groupValue.push({"id":"slideShowStyle","name":"slideShowStyle","type":"radio","label":"图片显示方式","typeChoose":"default","value":
                [{"label":"等比缩放自适应","id":"zoom","name":"zoom","checked":(dataJson&&dataJson.style=='1')?"on":"off","value":"3"},
                    {"label":"等比缩放显示全图","id":"zoom","name":"zoom","checked":(dataJson&&dataJson.style=='2')?"on":"off","value":"3"},
                    {"label":"拉伸","id":"stretch","name":"stretch","checked":(dataJson&&dataJson.style=='3')?"on":"off","value":"4"}]
                    ,"click":"clickFun"
			});
			json[0].groupValue.push({"id":"speed","name":"speed","type":"radio","label":"轮播速度","typeChoose":"default","value":
                [{"label":"快速","id":"speed1","name":"speed1","checked":(dataJson&&dataJson.speed=='3000')?"on":"off","value":"3000"},
                    {"label":"中速","id":"speed2","name":"speed2","checked":(dataJson&&dataJson.speed=='5000')?"on":"off","value":"5000"},
                    {"label":"慢速","id":"speed3","name":"speed3","checked":(dataJson&&dataJson.speed=='8000')?"on":"off","value":"8000"}]
                    ,"click":"clickFun"
			});
		}
        return  json;
    },
    onPropChange : function(json,id,key,value){
    	if(key=='showSlide'){
        	window.parent.putData(key, value, "slide");//这个热点保存到hotspot
        	return;
        }
    	var newDataJson = this.getNewDataJson(json);
		if(!newDataJson._w){
			newDataJson._w = document.getElementById("wrapper").offsetWidth;
		}
		if(!newDataJson.style){
			newDataJson.style= "1";
		}
        if(newDataJson && newDataJson.value && newDataJson.value!="[]"){
        	document.getElementById("slideVPortal").innerHTML = "";
            var oldTPL = document.getElementById("tpl-slideVPortal").innerHTML;
            //渲染函数
            renderTpl(newDataJson,oldTPL,"slideVPortal");
            this.afterInit("slideVPortal");
        }
    },
    saveProp : function(){
        var newDataJson = this.getNewDataJson(null);
        if(newDataJson){
        	callBackendMethod("slideVPortalManager","saveSlideVPortal",newDataJson,{
                success: function(result){
                    console.log(result);
                }
            });
        }
    },
    getNewDataJson : function (json) {
    	if(vPortal.admin != 'true'){//非管理员不允许设置热点(是否显示除外)
    		return null;
    	}
        if (json != null){
            this.slideVPortalPropJson = json;
        }
        var newDataJson = this.slideVPortalDataJson;
        if(this.slideVPortalPropJson && this.slideVPortalPropJson.groupValue){
        	var hiddenValue = this.slideVPortalPropJson.groupValue[1].hiddenValue;
            var ids = hiddenValue[0].split(",");
            var titles = hiddenValue[1].split(",");
            var urls = hiddenValue[2].split(",");
            var backgroundPicture = new Array();
            for (var i=0;i<ids.length;i++) {
                var banner = new Object();
                if (ids[i] != "") {
                    banner.bannerImageId = ids[i];
                    banner.bannerImageTitle = titles[i];
                    banner.bannerImageUrl = urls[i];
                    backgroundPicture.push(banner);
                }
            }
            newDataJson.value = JSON.stringify(backgroundPicture);
            newDataJson.themeId = vPortal.themeId;
            newDataJson.portalId = vPortal.portalId;
            var slideShowStyle = this.slideVPortalPropJson.groupValue[2].value;
            for (var i=0;i<slideShowStyle.length;i++) {
                if(slideShowStyle[i].checked == "on"){
                    newDataJson.style = i+1;
                }
            }
            var speed = this.slideVPortalPropJson.groupValue[3].value;
            for (var i=0;i<speed.length;i++) {
                if(speed[i].checked == "on"){
                    var speed = "";
                    if (i == 0) {
                        speed = "3000";
                    } else if (i == 1) {
                        speed = "5000";
                    } else if (i == 2) {
                        speed = "8000";
                    }
                    newDataJson.speed = speed;
                }
            }
            return newDataJson;
        }else{
        	return null;
        }

    }
}

