/*
 * 顶部右侧操作区
 */
vPortalMainFrameElements.topRightsystemOperation = {
    config: !(vPortal.subPortal == "true"),
    afterInit: function(_domId, _menuData) {
        if (showSkinchoose == "true") {
            vPortalMainFrameElements.topRightsystemOperation.showSkinPanle();
        }
    },
    getData: function() {
        if (typeof(vPortal.themeHotspots.topRightsystemOperation) == "undefined") {
            vPortal.themeHotspots.topRightsystemOperation = {
                "btnBack": "0",
                "btnSign": "1",
                "btnSignStyle": "icon",
                "btnSearch": "1",
                "btnRefresh": "0",
                "btnSalaryView": "1",
                "btnProductNav": "0",
                "btnAppCenter": "1",
                "btnHomeSet": "1",
                "btnGo": "0",
                "btnMessage": "1"
            };
        }
        return vPortal.themeHotspots.topRightsystemOperation;
    },
    //在线人数
    onlineMember: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        onlineMember();
    },
    //个人中心
    showPersonCenter: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        showPersonCenter();
    },
    // 在线打卡
    onlineCardClick: function() {
        showMenu(_ctxPath + "/attendance/attendance.do?method=intoMyAttendance");
    },
    // 点击之后显示搜索框
    searchOpen: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        document.getElementById("searchContainer").style.display = "block";
        document.getElementById("searchAreaInput").focus();
    },
    searchClose: function() {
        document.getElementById("searchContainer").style.display = "none";
    },
    // 按了回车键
    pressEnter: function(_inputId) {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        vPortalMainFrameElements.commonSearch.pressEnter(_inputId);
    },
    // 点了搜索按钮
    search: function(_inputId) {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        vPortalMainFrameElements.commonSearch.search(_inputId);
    },
    // 唤醒致信
    msgClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        wakeZX();
    },
    // 点击高级搜索按钮
    searchArea: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        var keywordUrl = _ctxPath + '/index/indexController.do?method=search';
        showMenu(keywordUrl);
        document.getElementById("searchContainer").style.display = "none";
    },
    //刷新
    refreshPageClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        window.onbeforeunload = null;
        outSysFlag=false;
        window.location.reload();
    },
    // 隐藏hover出来的菜单区域
    // hideContainer: function(){
    // var personContainer = document.getElementById("personContainer");
    // personContainer.style.display = "none";
    // },
    // 显示/隐藏换肤面板
    showSkinPanle: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        var panleObj = document.getElementById("skin_set");
        var skin_content = document.getElementById("skin_content");
        if (panleObj.className.indexOf("display_none") !== -1) {
            panleObj.className = "skin_set_contaner";
            panleObj.style.display = "block";
            panleObj.style.height = "330px";
            skin_content.innerHTML = '<iframe src="/seeyon/portal/portalController.do?method=skinSet&portalId=' + vPortal.portalId + '&themeId=' + vPortal.themeId + CsrfGuard.getUrlSurffix() + '" width="100%" height="330px" frameborder="0"></iframe>';
        }
    },
    // 个人设置
    mySetClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        var url = "/personalAffair.do?method=personCenter&read=myConfig";
        var html = "<span class='nowLocation_ico'><img src='/seeyon/main/skin/frame/default/menuIcon/personal.png'/></span>";
        html += "<span class='nowLocation_content'>";
        html += "<a class=\"hand\" onclick=\"showMenu('" + _ctxPath +
            "/portal/portalController.do?method=personalInfo')\">" +
            $.i18n("menu.personal.affair") + "</a>";
        html += "</span>";
        showMenu(_ctxPath + url);
        hideLocation();

    },
    // 产品导航
    productViewClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        productView_Obj = $.dialog({
            id: 'productView',
            width: 1000,
            height: 640,
            checkMax: false,
            type: 'panel',
            url: _ctxPath +
                "/portal/portalController.do?method=showProductView",
            shadow: true,
            showMask: true,
            title: false,
            panelParam: {
                'show': false,
                'margins': false
            },
            closeParam: {
                show: false
            }
        });
    },
    // 薪资查看
    viewSalaryClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        var url = "/hrViewSalary.do?method=viewSalary";
        var html = "<span class='nowLocation_ico'><img src='/seeyon/main/skin/frame/default/menuIcon/personal.png'/></span>";
        html += "<span class='nowLocation_content'>";
        html += "<a class=\"hand\" onclick=\"showMenu('" + _ctxPath +
            "/portal/portalController.do?method=personalInfo')\">" +
            $.i18n("menu.personal.affair") + "</a>";
        html += " &gt; <a class=\"hand\" onclick=\"showMenu('" + _ctxPath +
            "/portal/portalController.do?method=personalInfoFrame&path=" +
            url + "')\">" + $.i18n("menu.hr.salary.show") + "</a>";
        html += "</span>";
        showLocation(html);
        showMenu(_ctxPath +
            "/portal/portalController.do?method=personalInfoFrame&path=" +
            url);
    },
    // 云中心
    appcenterClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        var url = _ctxPath + "/mallindex.do";
        window.open(url, "appcenter_id");
    },
    // 关于
    showAbout: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        var dialog = $.dialog({
            id: "showAbout",
            url: _ctxPath + "/main.do?method=showAbout",
            width: 504,
            height: 303,
            title: $.i18n("product.about.title"),
            buttons: [{
                text: $.i18n("common.button.close.label"),
                handler: function() {
                    dialog.close();
                }
            }]
        });
    },
    // 退出
    logoutClick: function() {
        if(vPortal && vPortal.isDesigner){
            return;
        }
        if (vPortal.subPortal == "true") {
            var ok = confirm("确认关闭该门户吗？");
            if (ok) {
                window.close();
            }
        } else {
            logout();
        }
    },
    // 设计器中获取可设置属性
    getProp: function(_dataJson) {
        window.parent.changeRightTitle('按钮设置');
        var dataJson = _dataJson.topRightsystemOperation;
        var json = [{
            "groupName": "图标显示",
            "groupType": "",
            "groupValue": [{
                    "id": "",
                    "name": "",
                    "type": "checkbox",
                    "label": "",
                    "typeChoose": "default",
                    "value": [{
                        "label": "应用中心",
                        "id": "btnAppCenter",
                        "name": "btnAppCenter",
                        "checked": (dataJson && dataJson.btnAppCenter == '1') ? "on" :
                            "off"
                    }],
                    "click": "clickFun"
                }, {
                    "id": "",
                    "name": "",
                    "type": "checkbox",
                    "label": "",
                    "typeChoose": "default",
                    "value": [{
                        "label": "搜索",
                        "id": "btnSearch",
                        "name": "btnSearch",
                        "checked": (dataJson && dataJson.btnSearch == '1' && vPortal.searchEnabled) ? "on" :
                            "off"
                    }],
                    "click": "clickFun"
                },
                // {
                // 	"id" : "",
                // 	"name" : "",
                // 	"type" : "checkbox",
                // 	"label" : "",
                // 	"typeChoose" : "default",
                // 	"value" : [ {
                // 		"label" : "前进",
                // 		"id" : "btnGo",
                // 		"name" : "btnGo",
                // 		"checked" : (dataJson && dataJson.btnGo == '1') ? "on"
                // 				: "off"
                // 	} ],
                // 	"click" : "clickFun"
                // },
                // {
                // 	"id" : "",
                // 	"name" : "",
                // 	"type" : "checkbox",
                // 	"label" : "",
                // 	"typeChoose" : "default",
                // 	"value" : [ {
                // 		"label" : "后退",
                // 		"id" : "btnBack",
                // 		"name" : "btnBack",
                // 		"checked" : (dataJson && dataJson.btnBack == '1') ? "on"
                // 				: "off"
                // 	} ],
                // 	"click" : "clickFun"
                // },
                {
                    "id": "",
                    "name": "",
                    "type": "checkbox",
                    "label": "",
                    "typeChoose": "default",
                    "value": [{
                        "label": "刷新",
                        "id": "btnRefresh",
                        "name": "btnRefresh",
                        "checked": (dataJson && dataJson.btnRefresh == '1') ? "on" :
                            "off"
                    }],
                    "click": "clickFun"
                }, {
                    "id": "",
                    "name": "",
                    "type": "checkbox",
                    "label": "",
                    "typeChoose": "default",
                    "value": [{
                        "label": "交流消息",
                        "id": "btnMessage",
                        "name": "btnMessage",
                        "checked": (dataJson && dataJson.btnMessage == '1') ? "on" :
                            "off"
                    }],
                    "click": "clickFun"
                }
            ]
        }, {
            "groupName": "菜单显示",
            "groupType": "",
            "groupValue": [{
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "首页设置",
                    "id": "btnHomeSet",
                    "name": "btnHomeSet",
                    "checked": (dataJson && dataJson.btnHomeSet == '1') ? "on" :
                        "off"
                }],
                "click": "clickFun"
            }, {
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "产品导航",
                    "id": "btnProductNav",
                    "name": "btnProductNav",
                    "checked": (dataJson && dataJson.btnProductNav == '1') ? "on" :
                        "off"
                }],
                "click": "clickFun"
            }, {
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "薪资查看",
                    "id": "btnSalaryView",
                    "name": "btnSalaryView",
                    "checked": (dataJson && dataJson.btnSalaryView == '1') ? "on" :
                        "off"
                }],
                "click": "clickFun"
            }, {
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "个人设置",
                    "id": "btnPersonalSet",
                    "name": "btnPersonalSet",
                    "disabled": true,
                    "checked": "on"
                }],
                "click": "clickFun"
            }, {
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "关于",
                    "id": "btnAbout",
                    "name": "btnAbout",
                    "disabled": true,
                    "checked": "on"
                }],
                "click": "clickFun"
            }, {
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "退出",
                    "id": "btnOut",
                    "name": "btnOut",
                    "disabled": true,
                    "checked": "on"
                }],
                "click": "clickFun"
            }]
        }];
        if (vPortal.cardEnabled) {
            json[0].groupValue.unshift({
                "id": "",
                "name": "",
                "type": "checkbox",
                "label": "",
                "typeChoose": "default",
                "value": [{
                    "label": "签到",
                    "id": "btnSign",
                    "name": "btnSign",
                    "checked": (dataJson && dataJson.btnSign == '1') ? "on" :
                        "off"
                }],
                "click": "clickFun"
            }, {
                "id": "btnSignStyle",
                "name": "btnSignStyle",
                "type": "select",
                "typeShow": "half",
                "label": "签到样式",
                "typeChoose": "default",
                "value": [{
                    "label": "文字",
                    "value": "text",
                    "select": (dataJson && dataJson.btnSignStyle == 'text') ? "on" :
                        "off"
                }, {
                    "label": "图标",
                    "value": "icon",
                    "select": (dataJson && dataJson.btnSignStyle == 'icon') ? "on" :
                        "off"
                }],
                "click": ""
            });
        }
        return json;
    },
    onPropChange: function(json, id, key, value) {
        for (var i = 0; i < json.groupValue.length; i++) {
            if (json.groupValue[i].type == "select") {
                if (value == "text") {
                    $("#" + id).find(".topIco").find(".signBtn").find("span").show();
                    $("#" + id).find(".topIco").find(".signBtn").find("i").hide();
                } else if (value == "icon") {
                    $("#" + id).find(".topIco").find(".signBtn").find("span").hide();
                    $("#" + id).find(".topIco").find(".signBtn").find("i").show();
                }
            } else {
                if (!vPortal.cardEnabled) {
                    if (i == 0) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".appIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".appIco").hide();
                        }
                    } else if (i == 1) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".searchIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".searchIco").hide();
                        }
                    } else if (i == 2) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".refreshIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".refreshIco").hide();
                        }
                    } else if (i == 3) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".messageIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".messageIco").hide();
                        }
                    }
                    if (i == 1) {
                        if ($("#largeSearch").length > 0) {
                            if (json.groupValue[i].value[0].checked == "on") {
                                $("#largeSearch").show();
                            } else if (json.groupValue[i].value[0].checked == "off") {
                                $("#largeSearch").hide();
                            }
                        }
                    }
                } else {
                    if (i == 0) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".signBtn").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".signBtn").hide();
                        }
                    } else if (i == 2) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".appIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".appIco").hide();
                        }
                    } else if (i == 3) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".searchIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".searchIco").hide();
                        }
                    } else if (i == 4) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".refreshIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".refreshIco").hide();
                        }
                    } else if (i == 5) {
                        if (json.groupValue[i].value[0].checked == "on") {
                            $("#" + id).find(".topIco").find(".messageIco").show();
                        } else if (json.groupValue[i].value[0].checked == "off") {
                            $("#" + id).find(".topIco").find(".messageIco").hide();
                        }
                    }
                    if (i == 3) {
                        if ($("#largeSearch").length > 0) {
                            if (json.groupValue[i].value[0].checked == "on") {
                                $("#largeSearch").show();
                            } else if (json.groupValue[i].value[0].checked == "off") {
                                $("#largeSearch").hide();
                            }
                        }
                    }
                }
                for (var j = 0; j < $(".commonShade").length; j++) {
                    var tempCommonShade = $(".commonShade").eq(j);
                    tempCommonShade.css({
                        "width": $("#" + tempCommonShade.attr("data-id"))
                            .children().eq(0).outerWidth() +
                            "px"
                    });
                    tempCommonShade.css({
                        "left": $("#" + tempCommonShade.attr("data-id"))
                            .children().eq(0).offset().left +
                            "px"
                    });
                }
            }
        }
        window.parent.putData(key, value, "topRightsystemOperation");
    },
    showHelp: function() {
        if (vPortal.systemHelp_sysProperty == "7") {
            window.open("http://open.seeyon.com/userHelp/V6.0SP1/7/index.html");
            return;
        }

        var url = _ctxPath + "/help/user_" + vPortal.systemHelp_sysProperty +
            ".html";
        if (vPortal.admin == "true") {
            url = _ctxPath + "/help/admin_" + vPortal.systemHelp_sysProperty +
                ".html";
        }
        var _v3x = new V3X();
        _v3x.openWindow({
            url: url,
            width: "700",
            height: "640",
            scrollbars: "yes",
            resizable: "yes",
            dialogType: "open"
        });
        _v3x = null;
    },
    // 布局设置和皮肤设置切换
    chooseOperate: function(_num) {
        var _contentWindow = document.getElementById("skin_content")
            .querySelector("iframe").contentWindow;
        if (document.querySelector(".skin_top_bar_left").children[0].classList) {
            if (_num == 0) {
                document.querySelector(".skin_top_bar_left").children[0].classList
                    .add("choosed");
                //				document.querySelector(".skin_top_bar_left").children[1].classList
                //						.remove("choosed");
                _contentWindow.toggleSet(_num);
            } else if (_num == 1) {
                document.querySelector(".skin_top_bar_left").children[0].classList
                    .remove("choosed");
                //				document.querySelector(".skin_top_bar_left").children[1].classList
                //						.add("choosed");
                _contentWindow.toggleSet(_num);
            }
        } else {
            if (_num == 0) {
                document.querySelector(".skin_top_bar_left").children[0]
                    .setAttribute("class",
                        "padding_l_5 hand padding_r_5 choosed");
                //				document.querySelector(".skin_top_bar_left").children[1]
                //						.setAttribute("class", "padding_l_5 hand padding_r_5");
                _contentWindow.toggleSet(_num);
            } else if (_num == 1) {
                document.querySelector(".skin_top_bar_left").children[0]
                    .setAttribute("class", "padding_l_5 hand padding_r_5");
                //				document.querySelector(".skin_top_bar_left").children[1]
                //						.setAttribute("class",
                //								"padding_l_5 hand padding_r_5 choosed");
                _contentWindow.toggleSet(_num);
            }
        }
    },
    spaceSet: function() {
        var dwidth = $(top).width();
        var dheight = $(top).height();
        var vPortalWindowDialog = $.dialog({
            targetWindow: top,
            id: 'spaceSetDialog',
            url: "/seeyon/portal/portalDesigner.do?method=vPortalEngineIndex&securityType=0&selected=space&from=dialog",
            width: dwidth,
            height: dheight,
            title: "空间设置",
            overflow: 'hidden',
            transParams: {
                vPortalWindowDialogObj: window
            },
            closeParam: {
                'show': true,
                handler: function() {
                    if(getCtpTop()["removeOnbeforeunload"]!=null){
                        getCtpTop()["removeOnbeforeunload"]();
                    }
                    getCtpTop().location.reload();
                }
            }
        });
    }
}