/*
 * 兼职单位
 */

vPortalMainFrameElements.concurrentAccount = {
    //获取兼职单位的数据
    getData: function() {
        //如果人员的单位信息大于1条，表示有兼职单位，需要渲染兼容单位，否则不渲染，返回false
        return vPortal.concurrentAccount.length > 1 ? vPortal.concurrentAccount : false;
    },
    //初始化，元素如果有初始化的事件请写在这里面
    init: function(_elementId) {
        return;
    },
    //点击下拉箭头，显示兼职单位
    showConcurrentList: function(event) {
        event.stopPropagation ? event.stopPropagation() : event.cancelBubble = true;
        event.preventDefault ? event.preventDefault() : event.returnValue = true;
        document.getElementById("concurrentList").style.display = "block";
    },
    //点击单位，切换单位
    changeConcurrent: function(_id) {
        var accountList = vPortal.concurrentAccount;
        var chgAccountName = null;
        for (var i = 0; i < accountList.length; i++) {
            if (accountList[i].id == _id) {
                chgAccountName = accountList[i].shortName;
            }
        }
        var _wmp = _windowsMap;
        for (var p = 0; p < _wmp.keys().size(); p++) {
            var _kkk = _wmp.keys().get(p);
            try {
                var _fff = _wmp.get(_kkk);
                var _dd = _fff.document;
                if (_dd) {
                    var _p = parseInt(_dd.body.clientHeight);
                    if (_p == 0) {
                        _dd.write('');
                        _fff.close();
                        _fff = null;
                        _wmp.remove(_kkk);
                        p--;
                    }
                } else {
                    _fff = null;
                    _wmp.remove(_kkk);
                    p--;
                }
            } catch (e) {
                _fff = null;
                _wmp.remove(_kkk);
                p--;
            }
        }

        if (_windowsMap.size() > 0) {
            if (confirm($.i18n("window.exit.isClose"))) {
                var _keys = _windowsMap.keys();
                for (var i = 0; i < _keys.size(); i++) {
                    var _k = _keys.get(i);
                    var _tp = _windowsMap.get(_k);
                    if (_tp)
                        _tp.close();
                }
            } else {
                return;
            }
        }
        document.querySelector("#concurrentList").style.display = "none";
        $.confirm({
            'type': 1,
            'msg': $.i18n('system.changeAccount.label', chgAccountName),
            ok_fn: function() {
            	var isExceedMaxLoginNumber=callBackendMethod("portalManager","isExceedMaxLoginNumberServerInAccount",_id);

                if (true != isExceedMaxLoginNumber) {
                    try {
                    	removeOnbeforeunload();
                        window.location.href = _ctxPath + "/main.do?method=changeLoginAccount&login.accountId=" + _id;
                    } catch (e) {}
                } else {
                    $.alert($.i18n('login.label.ErrorCode.31', chgAccountName));
                }
            },
            cancel_fn: function() {
                $("#chanageLoginAccount").find("option").each(function(i, obj) {
                    if (obj.value == $.ctx.CurrentUser.loginAccount) {
                        obj.selected = true;
                    } else {
                        obj.selected = false;
                    }
                });
            }
        });
    },
    //鼠标离开兼职单位列表时，隐藏列表
    hideConcurrentList: function() {
        document.querySelector("#concurrentList").style.display = "none";
    }
}