/*
 * 极简版的导航，导航可能包含这几类数据：门户,空间(包含第三方系统空间),关联系统空间,项目空间
 */
vPortalMainFrameElements.miniNav = {
    config: parent.canConfigNav == 'true' ? true : false,
    getData: function() {
        if (vPortal.offline || vPortal.portalType!=0) {//大屏和登录前门户直接用space中的数据，不要到导航中查询，如有疑问找wcw确认
            this.navData = vPortal.space;
            return vPortal.space;
        }
        //获取导航的数据
        var navs = replaceMenuIcon(getNavData(vPortal.portalId, "0"));
        //如果有导航数据，return它
        if (navs) {
            this.navData = navs;
            vPortal.space = navs;
        }
        return false;
    },
    afterInit: function(_domId, _menuData) {
        // 计算去掉顶部去掉左侧logo区和右侧操作区后，还能显示几个导航
        //替换里面的icon，去掉.png后续
        if (typeof(_menuData) !== "undefined" && typeof(_menuData) === "object" && _menuData.menus !== undefined) {
            var _navArray = replaceMenuIcon(_menuData.menus);
        } else {
            var _navArray = replaceMenuIcon(this.navData);
        }
        //实例化miniNav
        var _miniNav = new miniNav(_navArray, _domId, "tpl-miniNav");
        _miniNav = null;
    },
    showNavigation: function(_index, _obj) {
        showCurrentNav(this.navData[_index],"miniNav",_obj);
    },
    //设计器中获取可设置属性
    getProp: function(_dataJson) {
        window.parent.changeRightTitle('导航设置');
        var dataJson = _dataJson.topCenterSpaceNav;
        return tplNavJson(dataJson,"1","0","1");
    },
    onPropChange: function(json, id, key, value) {
        tplNavPropChange(key, value);
    }
}

var miniNav = function(_navArray, _domId, _tplName) {
    //this arguments
    this.domId = _domId;
    this.navJson = _navArray;
    this.tplHTML = document.getElementById(_tplName).innerHTML;
    renderTpl(this.navJson, this.tplHTML, this.domId)
}