/*
 * 宽尺寸logo
 */
vPortalMainFrameElements.wideLogoNew = {
    config : false,
    // 拼装数据，将多个对象拼装为了个对象，供渲染时使用
    getData : function() {
        return getLogoAndShortName("wideLogo");
    },
    // 渲染后计算宽度，如果logo+单位名称总宽度超过600了，重算单位名称的宽度
    afterInit : function() {
        // logo区宽度的处理
        setLogoAreaWidth();
        // 集团名称和单位名称垂直居中
        setLogoVerticalMiddle();
        // logo后显示内容
        setLogoText("logoAndName");
    },
    // 设计器中获取可设置属性
    getProp : function(_dataJson) {
        var dataJson = _dataJson.wideLogo;
        window.parent.changeRightTitle('logo属性设置');
        return tplLogoJson(dataJson, vPortal.subPortal == "true");
    },
    onPropChange : function(json, id, key, value) {
        if (key == "logoHeight") {
            var check = false;
            if (value && value != "") {
                var numPattern = new RegExp("^\\d+$");
                if (numPattern.test(value) && value >= 40 && value <= 250) {
                    check = true;
                }
            }
            if (!check) {
                window.parent.$.alert("logo高度值为40-250之间数字!");
                //大屏默认值 现状是70
                if (vPortal.portalType === "2") {
                    window.parent.$("#logoHeight").val("71");
                }
                return "false";
            }
        }
        if (json.groupValue[0].value) {
            $("#" + id).find("img").attr("src", json.groupValue[0].value);
        }
        if (json.groupValue[1].value) {
            if (json.groupValue[1].value[0].checked == "on") {
                $("#" + id).find("img").css({
                    "height" : "auto"
                });
            } else if (json.groupValue[1].value[1].checked == "on") {
                $("#" + id).find("img").css({
                    "height" : "auto",
                    "width" : "auto"
                });
                // var _companyNames = document.querySelector("#logoAndName .companyNames");
                // if (vPortal.portalType === "2") {
                //     // _companyNames.style.paddingTop = "15px";
                //     // // _companyNames.style.lineHeight = "40px";
                //     // if (_companyNames.querySelector(".cnName")) {
                //     //     _companyNames.querySelector(".cnName").style.fontSize = "40px";
                //     // }
                // }
            }
        }

        setLogoHeight(json, id, key, value);
        if(key === "logoHeight"){
            window.parent.putData(key, $("#" + id).height(), "wideLogo");
        }else{
            window.parent.putData(key, value, "wideLogo");
        }
        window.parent.$("#logoHeight").val($("#" + id).height());
        window.parent.skinIsChange = true;
    }
}