"use strict";
/**
* layout02布局下的相关功能
* @author huy
* @date 2017-09-06
*/
vPortal.layoutName = "layout_c001_a";
vPortal.layoutFunction = {
    init: function(_url,_target) {
        this.transformers(_url,_target);
    },
    transformers: function(_url,_target) {
        //对工作区进行一些变形，以适合于二级页面的展示
        if(_url.indexOf("method=showThemSpace") > -1 && _target !=="newWindow"){
            document.getElementById("wrapper").className = "wrapper isTransformers isThemeSpace";
        }else if(_target !=="newWindow"){
            document.getElementById("wrapper").className = "wrapper isTransformers";
        }
        //是否变形至适合展示二级页面了
        vPortal.isTransmutative = true;
    },
    recoverIndexLayout: function(_openType) {
        if(_openType !=="newWindow"){
            //恢复变形
            document.getElementById("wrapper").className = "wrapper";
            vPortal.isTransmutative = false;
        }
    }
};

//设计器头部区域高度设置
var topHeightChange = function (_height) {
    if(!vPortal.isIE8){
        var textNode="<style>" +
            ".seeyon-portal-header{height: "+ _height +"px;}" +
            ".seeyon-portal-header{line-height: "+ _height +"px;}" +
            ".seeyon-portal-header .seeyon-portal-header-top{height: "+ _height +"px;}" +
            "</style>";
        $(document.body).append(textNode);
    }else{
        $(".seeyon-portal-header").css("line-height",_height +"px");
        $(".seeyon-portal-header,.seeyon-portal-header .seeyon-portal-header-top").css("height",_height +"px");
    }
};